#include <iostream>
#include <fstream>

int main(int argc, char *argv[]) {
    if (argc<3) exit(1);

    // open the texture file
    std::ifstream file;
    file.open(argv[1], std::ios::in | std::ios::binary);
    if(!file)
    {
	std::cerr << "Texture file '" << argv[1] << "' not found." << std::endl;
	return 0;
    }

    // load the dimension of the texture
    int width;
    file.read((char *)&width, 4);
    int height;
    file.read((char *)&height, 4);
    int depth;
    file.read((char *)&depth, 4);

    // allocate a temporary buffer to load the texture to
    unsigned char *pBuffer;
    pBuffer = new unsigned char[2 * width * height * depth];
    if(pBuffer == 0)
    {
	std::cerr << "Memory allocation for texture failed." << std::endl;
	return 0;
    }

    // load the texture
    file.read((char *)pBuffer, width * height * depth);

    // explicitely close the file
    file.close();
    std::ofstream out(argv[2], std::ios::out | std::ios::binary);
    out << "P6\n" << width << " " << height << "\n255" << std::endl;
    out.write((char*)pBuffer, width * height * depth);
    out.close();
    std::cout << "width: " << width << " height: " << height << std::endl;


}
